<?php
/**
 * 另一个飘雪插件
 * 
 * @package Snow3
 * @author 清馨雅致
 * @version 1.0.0
 * @link http://minwenlsm.pw
 */
class Snow3_Plugin implements Typecho_Plugin_Interface
{
    /**
     * 激活插件方法,如果激活失败,直接抛出异常
     * 
     * @access public
     * @return void
     * @throws Typecho_Plugin_Exception
     */
    public static function activate()
    {
        Typecho_Plugin::factory('Widget_Archive')->header = array('Snow3_Plugin', 'Snow3');
    }
    
    /**
     * 禁用插件方法,如果禁用失败,直接抛出异常
     * 
     * @static
     * @access public
     * @return void
     * @throws Typecho_Plugin_Exception
     */
    public static function deactivate(){}
   
    /**
     * 获取插件配置面板
     * 
     * @access public
     * @param Typecho_Widget_Helper_Form $form 配置面板
     * @return void
     */
    public static function config(Typecho_Widget_Helper_Form $form){}
    
    /**
     * 个人用户的配置面板
     * 
     * @access public
     * @param Typecho_Widget_Helper_Form $form
     * @return void
     */
    public static function personalConfig(Typecho_Widget_Helper_Form $form){}
    
    /**
     * 输出JS
     * 
     * @access public
     * @return void
     */
    public static function Snow3(){
		$jsUrl = Helper::options()->pluginUrl . '/Snow3/js/Snow3.js';
        echo '<script type="text/javascript" src="'.$jsUrl.'"></script>' . "\n";
    }
}